var exclamations = 0;

function load() {
	var exclamation = document.getElementById("exclamation");
	exclamation.value = widget.preferenceForKey("exclamationLevel");
}

function translate()
{
	var english = document.getElementById("english");
	var pirate = document.getElementById("pirate");
	pirate.value = '';
	getTranslation(english.value);
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
	// widget.setPreferenceForKey(null, "your-key");
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

function setExclamation() {
	widget.setPreferenceForKey("exclamationLevel", this.value);
}

function getTranslation(_english) {
		var pirate = document.getElementById('pirate');
		pirate.value = 'Translating...';
		var exclamationLevel = Number(document.getElementById("exclamation").value);
		var data = 'client=dashboard&version=1.2&exclamation=' + exclamationLevel + '&english=' + encodeURIComponent(_english);
		xml_request = new XMLHttpRequest();

		xml_request.onload = function(e) {receiveTranslation(e, xml_request);}
		xml_request.overrideMimeType("text/xml");
		xml_request.open("POST", 'http://pirate.monkeyness.com/cgi-bin/translator.pl');
		xml_request.setRequestHeader("Cache-Control", "no-cache");
		xml_request.send(data);
}

function receiveTranslation (e, request) {
	xml_request = null;
	var response = convertXMLtoObj(request.responseXML, 0);
	if (request.responseText) {
		var pirate = document.getElementById('pirate');
		pirate.value = response.pirateAPI.pirate;
		if (response.pirateAPI.version > 1.2) {
			var text1 = document.getElementById('text1');
			text1.innerHTML = '<a href="javascript:widget.openURL(\'http://pirate.monkeyness.com/dashboard_pirate_translator?client=dashboard\');">Version ' + response.pirateAPI.version + '</a> is available';
		} else if (response.pirateAPI.message) {
			var text1 = document.getElementById('text1');
			text1.innerHTML = response.pirateAPI.message;
		}
	}
}

function convertXMLtoObj(_xml, _depth) {
	var xml = _xml;
	var hash = new Object();
	var tabs = '';
	for (var tab = 0; tab < _depth; tab++) { tabs += '- '; }
	if (typeof xml == 'object') {
		var cnt = 0;
		for (var a = 0; a < xml.childNodes.length; a++) {
			var name = xml.childNodes[a]['nodeName'];
			if (xml.childNodes[a]['nodeName'] == '#text') {
			} else if (typeof xml.childNodes[a] == 'object') {
				var type = xml.childNodes[a]['type'];
				if (type == 'array') {
					if (!hash[name]) {
						if ((typeof xml.childNodes[a] == 'object') && (xml.childNodes[a].childNodes.length > 1)) {
							var value = xml.childNodes[a].firstChild.data;
							hash[name] = [convertXMLtoObj(xml.childNodes[a], Number(_depth) + 2)];
						} else {
							var value = xml.childNodes[a].firstChild.data;
							hash[name] = [value];
						}
					} else {
						if ((typeof xml.childNodes[a] == 'object') && (xml.childNodes[a].childNodes.length > 1)) {
							var value = xml.childNodes[a].firstChild.data;
							hash[name].push(convertXMLtoObj(xml.childNodes[a], Number(_depth) + 2));
						} else {
							var value = xml.childNodes[a].firstChild.data;
							hash[name].push(value);
						}
					}
					cnt++;
				} else if ((typeof xml.childNodes[a] == 'object') && (xml.childNodes[a].childNodes.length > 1)) {
					var value = '';
					if (xml.childNodes[a] && xml.childNodes[a].childNodes[0]) { value = xml.childNodes[a].childNodes[0]['data']; }
					hash[name] = convertXMLtoObj(xml.childNodes[a], Number(_depth) + 1);
					cnt++;
				} else {
					var value = '';
					if (xml.childNodes[a] && xml.childNodes[a].childNodes[0]) { value = xml.childNodes[a].childNodes[0]['data']; }
					hash[name] = value;
					cnt++;
				}
			}
		}
	}
	return hash;
}
